#include <Buttons.h>
#include <Display.h>
#include <Gamebuino.h>
#include <SPI.h>
#include <Sound.h>
#include <EEPROM.h>
#include <avr/pgmspace.h>
Gamebuino gb;

int pro = 1;
int con = 52;
int o = 0;
int a = 0;
int m = 0;
int d = 0;
int j = 0;
int x = 0;

extern const byte font5x7[];

char *deckb[52] =
{
  "A\3", "2\3", "3\3", "4\3", "5\3", "6\3", "7\3", "8\3", "9\3", "10\3", "J\3", "Q\3", "K\3",
  "A\4", "2\4", "3\4", "4\4", "5\4", "6\4", "7\4", "8\4", "9\4", "10\4", "J\4", "Q\4", "K\4",
  "A\5", "2\5", "3\5", "4\5", "5\5", "6\5", "7\5", "8\5", "9\5", "10\5", "J\5", "Q\5", "K\5",
  "A\6", "2\6", "3\6", "4\6", "5\6", "6\6", "7\6", "8\6", "9\6", "10\6", "J\6", "Q\6", "K\6"
};

char *deck[52] =
{
  "A\3", "2\3", "3\3", "4\3", "5\3", "6\3", "7\3", "8\3", "9\3", "10\3", "J\3", "Q\3", "K\3",
  "A\4", "2\4", "3\4", "4\4", "5\4", "6\4", "7\4", "8\4", "9\4", "10\4", "J\4", "Q\4", "K\4",
  "A\5", "2\5", "3\5", "4\5", "5\5", "6\5", "7\5", "8\5", "9\5", "10\5", "J\5", "Q\5", "K\5",
  "A\6", "2\6", "3\6", "4\6", "5\6", "6\6", "7\6", "8\6", "9\6", "10\6", "J\6", "Q\6", "K\6"
};

const byte logo[] PROGMEM = {56,30,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,0x80,0x0,0x0,0x0,0x0,0x0,0x20,0x80,0x0,0x0,0x0,0x0,0x0,0x20,0x80,0x0,0x0,0x0,0x0,0x0,0x20,0x8F,0x8E,0x3B,0x89,0xCC,0x3E,0x20,0x8C,0xE4,0x65,0x93,0x2C,0x10,0x20,0x8C,0x64,0xC5,0x96,0x2C,0x10,0x20,0x8C,0x64,0xDC,0xE6,0xEC,0x10,0x20,0x8C,0x64,0xC8,0xE6,0x4C,0x10,0x20,0x8C,0x65,0xC0,0x66,0xC,0x10,0x20,0x8C,0xC4,0xC0,0x66,0xC,0x1E,0x20,0x8D,0x84,0xC0,0x66,0xC,0x13,0x20,0x8F,0xC4,0xC4,0x66,0x2C,0x90,0x20,0x9C,0xE4,0xC4,0x67,0x2D,0x90,0x20,0x8C,0x64,0x78,0x3,0xEC,0x90,0x20,0x8C,0x64,0x0,0x0,0x8C,0x90,0x20,0x8C,0x66,0x0,0x0,0x1C,0x93,0x20,0x8C,0x68,0xF,0xFC,0x3,0x92,0x20,0x8C,0xE0,0xFF,0xFF,0xC1,0x92,0x20,0x8C,0xC3,0xFF,0xFF,0xF0,0x92,0x20,0x8D,0x87,0xF0,0x3,0xF8,0x31,0x20,0x8F,0x1F,0x80,0x0,0x7E,0x1D,0x20,0x8E,0x3E,0x0,0x0,0x1F,0xF,0x20,0x8C,0x78,0x0,0x0,0x7,0x83,0x20,0x98,0x70,0x0,0x0,0x3,0x81,0x20,0x90,0xE0,0x0,0x0,0x1,0xC1,0x20,0x80,0xE0,0x0,0x0,0x1,0xC1,0x20,0x81,0xC0,0x0,0x0,0x0,0xE0,0x20,0x81,0xC0,0x0,0x0,0x0,0xE0,0x20,0xFF,0xC0,0x0,0x0,0x0,0xFF,0xE0,};

void setup() {
  // initialize the Gamebuino object
  gb.begin();
  gb.display.setFont(font5x7);
  gb.titleScreen(F("Deck of Cards"), logo);
};

void loop() {
  if (gb.update()) {
    if ((x - j) < random(52, 208)){
      gb.display.println("Shuffling ");
      gb.display.print((x - j) / 1.56);
      gb.display.print("%");
      int a = (x - j) % 52;
      int p = random(0, 52);
      char *k = deck[p];
      char *f = deck[a];
      deck[p] = f;
      deck[a] = k;
    }
    else {
      if (gb.buttons.pressed(BTN_UP) && o <= 50) {
        o++;
      };
      if (gb.buttons.pressed(BTN_DOWN) && o > 0) {
        o--;
      };
      if (gb.buttons.pressed(BTN_B)) {
        for(int s = 0; s == 51; s++){
          deck[s] = deckb[s];
        }
        j = x;
      };
      gb.display.println(o + 1);
      gb.display.print(deck[o]);
    }
    if (gb.buttons.pressed(BTN_C)) {
      gb.titleScreen(F("Deck of Cards"), logo);
    };
    x++;
  }
}
